# Class CircleShape

java.lang.Object
com.codename1.gaming.physics.box2d.collision.shapes.Shape
com.codename1.gaming.physics.box2d.collision.shapes.CircleShape

public class CircleShape extends Shape
A circle shape.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `final Vec2`
  `m_p`

  ### Fields inherited from class Shape

  `m_radius, m_type`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CircleShape()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final Shape`
  `clone()`
  `final void`
  `computeAABB(AABB aabb, Transform transform, int childIndex)`
  Given a transform, compute the associated axis aligned bounding box for a child shape.
  `final void`
  `computeMass(MassData massData, float density)`
  Compute the mass properties of this shape using its dimensions and density.
  `final int`
  `getChildCount()`
  Get the number of child primitives
  `final int`
  `getSupport(Vec2 d)`
  Get the supporting vertex index in the given direction.
  `final Vec2`
  `getSupportVertex(Vec2 d)`
  Get the supporting vertex in the given direction.
  `final Vec2`
  `getVertex(int index)`
  Get a vertex by index.
  `final int`
  `getVertexCount()`
  Get the vertex count.
  `final boolean`
  `raycast(RayCastOutput output, RayCastInput input, Transform transform, int childIndex)`
  Cast a ray against a child shape.
  `final boolean`
  `testPoint(Transform transform, Vec2 p)`
  Test a point for containment in this shape.

  ### Methods inherited from class Shape

  `getRadius, getType, setRadius`

  ### Methods inherited from class Object

  `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### m_p

    public final Vec2 m_p

- ## Constructor Details

  - ### CircleShape

    public CircleShape()

- ## Method Details

  - ### clone

    public final Shape clone()
    Specified by:
      `clone` in class `Shape`

  - ### getChildCount

    public final int getChildCount()
    Description copied from class: `Shape`
    Get the number of child primitives
    Specified by:
      `getChildCount` in class `Shape`
    Returns:

  - ### getSupport

    public final int getSupport(Vec2 d)
    Get the supporting vertex index in the given direction.
    Parameters:
      `d` -
    Returns:

  - ### getSupportVertex

    public final Vec2 getSupportVertex(Vec2 d)
    Get the supporting vertex in the given direction.
    Parameters:
      `d` -
    Returns:

  - ### getVertexCount

    public final int getVertexCount()
    Get the vertex count.
    Returns:

  - ### getVertex

    public final Vec2 getVertex(int index)
    Get a vertex by index.
    Parameters:
      `index` -
    Returns:

  - ### testPoint

    public final boolean testPoint(Transform transform, Vec2 p)
    Description copied from class: `Shape`
    Test a point for containment in this shape. This only works for convex shapes.
    Specified by:
      `testPoint` in class `Shape`
    Parameters:
      `transform` - the shape world transform.
      `p` - a point in world coordinates.

  - ### raycast

    public final boolean raycast(RayCastOutput output, RayCastInput input, Transform transform, int childIndex)
    Description copied from class: `Shape`
    Cast a ray against a child shape.
    Specified by:
      `raycast` in class `Shape`
    Returns:
      if hit

  - ### computeAABB

    public final void computeAABB(AABB aabb, Transform transform, int childIndex)
    Description copied from class: `Shape`
    Given a transform, compute the associated axis aligned bounding box for a child shape.
    Specified by:
      `computeAABB` in class `Shape`

  - ### computeMass

    public final void computeMass(MassData massData, float density)
    Description copied from class: `Shape`
    Compute the mass properties of this shape using its dimensions and density. The inertia tensor is computed about the local origin.
    Specified by:
      `computeMass` in class `Shape`
    Parameters:
      `massData` - returns the mass data for this shape.
      `density` - the density in kilograms per meter squared.